"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = subpathReducer;

var _mapValues2 = _interopRequireDefault(require("lodash/mapValues"));

var _mindfrontReduxUtils = require("mindfront-redux-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function subpathReducer(subpath, initialState) {
  if (typeof subpath !== 'function') {
    const fixedSubpath = subpath;

    subpath = () => fixedSubpath;
  }

  return reducer => {
    const {
      actionHandlers
    } = reducer;

    if (actionHandlers instanceof Object) {
      const initialSubState = reducer.initialState;
      return (0, _mindfrontReduxUtils.createReducer)(initialState, (0, _mapValues2.default)(actionHandlers, reducer => (state, action) => state.updateIn(subpath(action), (substate = initialSubState) => reducer(substate, action))));
    }

    return (state = initialState, action) => state.updateIn(subpath(action), substate => reducer(substate, action));
  };
}