"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = subpathReducer;

var _mapValues2 = _interopRequireDefault(require("lodash/mapValues"));

var _mindfrontReduxUtils = require("mindfront-redux-utils");

function subpathReducer(subpath, initialState) {
  if (typeof subpath !== 'function') {
    var fixedSubpath = subpath;

    subpath = function subpath() {
      return fixedSubpath;
    };
  }

  return function (reducer) {
    var actionHandlers = reducer.actionHandlers;

    if (actionHandlers instanceof Object) {
      var initialSubState = reducer.initialState;
      return (0, _mindfrontReduxUtils.createReducer)(initialState, (0, _mapValues2.default)(actionHandlers, function (reducer) {
        return function (state, action) {
          return state.updateIn(subpath(action), function () {
            var substate = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialSubState;
            return reducer(substate, action);
          });
        };
      }));
    }

    return function () {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
      var action = arguments.length > 1 ? arguments[1] : undefined;
      return state.updateIn(subpath(action), function (substate) {
        return reducer(substate, action);
      });
    };
  };
}